/*
 * horizontalTreePlugin 1.0 - Plugin for jQuery
 * 
 * Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
 * and GPL (http://www.opensource.org/licenses/gpl-license.php) licenses.
 *
 * Depends:
 *   jquery.js
 * 
 *
 *  Copyright (c) 2010 Stephen Morrissey (stephen@it4today.net)#
 */
 
;(function($) {


    $.fn.extend({
        horTree: function(options) {
			var horTreeClass;		
			this.each(function() {
					var method = 'init',horTree = $.data(this, 'horTree') || $.data(this, 'horTree', new $.horTree(this, options));
					horTree[method].apply(horTree);
					horTreelass = horTree;		
			});			
		 return horTreeClass;
        }
    });




   $.horTree = function(the_tree_container, params) {

	
        /**************************************************************************/
        //Defaults

        var opts = {
			template_object:null,
			tree_data_object:null,
			tree_date_binding_character:'$$',
			extra_node_component_width:25,
            callBackFunctionAfterTreeGenerated:null,
			level_seperation_margin:null
        };
        $.extend(opts, params);

		var the_container_id = null;
        var level_counter = 0;
        var the_tree_html_code = '';
		var	node_counter = 0;	
		
        /**************************************************************************/
        //Private variables

        var 
			$the_tree_container = $(the_tree_container),
			$horTree = $horTree,
			the_container_id,
			level_counter = 0,
			the_tree_html_code =  '';

        /**************************************************************************/
        //Public variables

        this.$the_tree_container = $the_tree_container;
        this.$horTree = $horTree;
        /**************************************************************************/



        //Public methods
        this.init = function() {     
			the_container_id  = $the_tree_container.attr('id');
            if(this.validateParameters())
            {
                create();
                if(opts.callBackFunctionAfterTreeGenerated != null)// This allows the plugin to call a function outside after it has finished rendering the tree(s)
                {
                    window[opts.callBackFunctionAfterTreeGenerated](the_container_id)
                }
            }

        };

        this.validateParameters = function() {
			return true;
        };
		
		this.deleteNode = function(the_node_id){
			deleteNode(the_node_id);
		};

        this.addNode = function(the_node_id,location){
           // addNode(the_node_id,location);
			// To be implemented soon
        };
		

        /**************************************************************************/
        //Private methods
        function create() {
              var the_object_node = opts.tree_data_object;
              the_object_node.level = 0;
              $.data( $the_tree_container, 'total_levels',0);
              buildNodeChildren(the_object_node);
              $the_tree_container.append(the_tree_html_code);
              $('#' + the_container_id + ' .first_inlevel_node').parent().prepend('<td class="tree_node_connector_lines"><table class = "tree_connector_table"><tbody><tr><td></td></tr><tr><td class="tree_connector_vert_line"></td></tr></tbody></table></td>')
              $('#' + the_container_id + ' .last_inlevel_node').parent().prepend('<td class="tree_node_connector_lines"><table class = "tree_connector_table"><tbody><tr><td class="tree_connector_vert_line"></td></tr><tr><td ></td></tr></tbody></table></td>')
              $('#' + the_container_id + ' .middle_inlevel_node').parent().prepend('<td class="tree_node_connector_lines"><table class = "tree_connector_table"><tbody><tr><td class="tree_connector_vert_line"></td></tr><tr><td class="tree_connector_vert_line"></td></tr></tbody></table></td>')
              setUpNodeWidths();  

			  console.log(opts.level_seperation_margin);
			  if(opts.level_seperation_margin != null){
					$('#' + the_container_id + ' .level_container').css({'margin':opts.level_seperation_margin + 'px 0px'});
			  }
    

        };
		

		// Direct Tree Building Functions
		function setUpNodeWidths()
		{
            var total_levels = $.data( $the_tree_container, 'total_levels');
            var tree_id = $the_tree_container.attr('id');
            for(var i = 0; i <= total_levels;i++)
            {
                var level_width = 0;
                $('#' + tree_id + ' .level' + i + ' .node').each(function(){
                    if(level_width <= $(this).width())
                    {
                        level_width = $(this).width();
                    }
    
                });
				var level_width = level_width + opts.extra_node_component_width;
                $('#' + tree_id + ' .level' + i + ' .node').css('width',level_width);   
            }		
		}
		
		
		function createNode(the_node,level)
		{
             var binded_template = getTemplateCode(the_node);
			 node_counter = node_counter + 1;
			 addCodeToTree('<div class = "node" id = "'+the_container_id+'___'+ node_counter +'">' + binded_template + '</div>');               
		}
 
		function deleteNode(the_node_id)
		{
			var the_node_to_remove = $('#' + the_node_id);
			var the_row_td = the_node_to_remove.parents('.level_tree_table:first'); 
		
			if(the_node_to_remove.parent().hasClass('first_inlevel_node'))
			{
				var the_next_node = the_row_td.next();
                
				var connector_line_top = the_next_node.find('.tree_connector_table').find('td').eq(0);
                the_next_node.find('.middle_inlevel_node').addClass('first_inlevel_node').removeClass('middle_inlevel_node');	
				connector_line_top.removeClass('tree_connector_vert_line');			
				the_row_td.remove();
			}
			else if(the_node_to_remove.parent().hasClass('last_inlevel_node'))
			{
				var the_prev_node = the_row_td.prev();
                var connector_line_bottom = the_prev_node.find('.tree_connector_table').find('td').eq(1);	
                the_prev_node.find('.middle_inlevel_node').addClass('last_inlevel_node').removeClass('middle_inlevel_node');	
				connector_line_bottom.removeClass('tree_connector_vert_line');	
				the_row_td.remove();
			}
			else
			{
				the_row_td.remove();
			}
			
		}
 

        function addNode(new_node_id,the_node_id,location)
        {
			// To be implemented soon

        }

        function buildNodeChildren(the_object_node)
        {
            var children_array = the_object_node.children;
            if(children_array != null)
            {
                the_object_node.number_of_children =  children_array.length;       
   
                for (var i = 0; i < children_array.length; i++)
                {                
                    buildNodeAndChildren(i,the_object_node);            
                }   
               
            }
        
       }
        function buildNodeAndChildren(i,the_object_node)
        {
            var children_array = the_object_node.children;
            var number_of_children_in_this_level = children_array.length;
            var parent = the_object_node;
            var the_object_node = children_array[i];
            the_object_node.level = parent.level + 1;   
            var currentTotalLevel = $.data( $the_tree_container, 'total_levels');
            if(the_object_node.level > currentTotalLevel)
            {
                $.data( $the_tree_container, 'total_levels',the_object_node.level);
            }            
            var the_class = getClassLevel(the_object_node.level,number_of_children_in_this_level,i,the_object_node.children);           
		

            addCodeToTree('<table class = "level_tree_table"><tr><td class = "' + the_class + ' level'+the_object_node.level+'">');    
            
            createNode(the_object_node,i);
            if(the_object_node.children != null)
            {
                addCodeToTree('</td><td><div class = "level_container">'); 
                buildNodeChildren(the_object_node);   
            }
                        
            addCodeToTree('</div></td></tr></table>');          
        
        }
        
        
        function getClassLevel(level,children_in_level,current_location_in_level,object_children)
        {
            var node_class = 'tree_node '
            
            if(children_in_level == 1)
            {
                node_class = node_class + ' single_node '
            }
            else if(current_location_in_level == 0)
            {
               node_class = node_class + ' first_inlevel_node ' 
            }
            else if(current_location_in_level == (children_in_level - 1))
            {
                node_class = node_class + ' last_inlevel_node '
            }
            else // is in the middle of the level
            {
                node_class = node_class + ' middle_inlevel_node '
            }
            
            if(level == 1)//the root level
            {
                return node_class + 'tree_single_root';
            }
            else if(object_children == null) // last level
            {
                return node_class + 'tree_end_node';
            }
            else
            {
                return node_class + 'tree_middle_node';
            }
        }

		

// Binding Data Functions
        function findDataObjectFromKey(the_key,object)
        {
            var the_value = null;
            $(object).each(function(){
            
               if(the_key == this.Key)
               {
                    the_value = this.Value;
               }            
            });
            return the_value;
        }
        
        function getTemplateCode(object_node)
        {
            var data_template = findDataObjectFromKey(object_node.typeName,opts.template_object);
            var output_html = bindDataToTemplate(data_template,object_node);
            return (output_html);
        }
        
        
        function parseValues(the_string)
        {
            var char_container = opts.tree_date_binding_character;
            var start_pos = 0;
            var end_pos = 0;
            var length_of_string = 0;
            var key_array =  new Array();

            var counter = 0;
            while (the_string.indexOf(char_container) != -1 && counter < 10) {
                start_pos = the_string.indexOf(char_container) + char_container.length ;
                end_pos = the_string.indexOf(char_container, start_pos);
                length_of_string = end_pos - start_pos;
                key_array.push(the_string.substring(start_pos,end_pos));
                the_string = the_string.substring(end_pos + char_container.length);
                counter++;
            }            
            return key_array;
           
        }
        
                            
        function bindDataToTemplate(data_template,object_node)
        {
            var the_key_array = parseValues(data_template);
            var template_bindings = object_node.bindings;
  
            for (var i = 0; i < the_key_array.length; i++)                 
            {
                var the_key = the_key_array[i];
                var the_binding_value = findDataObjectFromKey(the_key,template_bindings);
                if(the_binding_value == null)
                {
                    objectInTemplateCouldNotFindBindingObjectError();
                }
                else
                {
                    data_template = data_template.replace("" + opts.tree_date_binding_character + the_key + opts.tree_date_binding_character, the_binding_value);
                }
            }
            return data_template;           
        }
// MISC FUNCTIONS
        
		function addCodeToTree(the_code)
        {
            the_tree_html_code = the_tree_html_code + the_code;
        }

        
		function validateParameters()
		{
		
			if(opts.template_object == null || opts.tree_data_object == null)
			{
				alertError(error.validation_error);
				return false;
			}		

			return true;

		}
		
		
// Error Functions		
        function objectInTemplateCouldNotFindBindingObjectError()
        {
            alert('the template object could not find a corresponding binding value');
        }
        
};
})(jQuery);		


	





